
% import data
PSID1 = importdata('PSID1.csv');
PCED1 = importdata('PCED1.csv');

N0=2069;  % number of cross-sectional units
T0=26;    % time length
K0=12;    % number of variables

% select the starting and final year (1(=1967) <= t <= 26(=1992))
t_start = 11;
t_end = 26;
T = t_end - t_start + 1;  % length of selected period

data0 = zeros(K0,T0,N0);

for i=1:N0
    data0(:,:,i) = PSID1(K0*(i-1)+1:K0*i,:);
end

for i=1:N0
    for t=1:T0
        if data0(5,t,i) == 0; data0(5,t,i) = NaN;  end
    end
end

data1 = data0(:,t_start:t_end,:);
data2=zeros(T,N0,K0);
j_ALL=1;
for i=1:N0
   if isnan(data1(:,:,i)) == zeros(K0,T);   data2(:,j_ALL,:)=reshape(data1(:,:,i)',T,1,K0); j_ALL=j_ALL+1; end 
end
N_ALL = j_ALL-1;
data_ALL = data2(:,1:N_ALL,:);

data_HSD = zeros(T,N_ALL,K0);
data_HSG = zeros(T,N_ALL,K0);
data_CLG = zeros(T,N_ALL,K0);
j_HSD=1;
j_HSG=1;
j_CLG=1;
for i=1:N_ALL
   if data_ALL(1,i,2) < 12;   data_HSD(:,j_HSD,:)=data_ALL(:,i,:); j_HSD=j_HSD+1; end 
   if data_ALL(1,i,2) >= 12 && data_ALL(1,i,2) <= 15;   data_HSG(:,j_HSG,:)=data_ALL(:,i,:); j_HSG=j_HSG+1; end 
   if data_ALL(1,i,2) > 15;   data_CLG(:,j_CLG,:)=data_ALL(:,i,:); j_CLG=j_CLG+1; end 
end
N_HSD = j_HSD - 1;
N_HSG = j_HSG - 1;
N_CLG = j_CLG - 1;
data_HSD = data_HSD(:,1:N_HSD,:);
data_HSG = data_HSG(:,1:N_HSG,:);
data_CLG = data_CLG(:,1:N_CLG,:);


% Y_ALL = log(data_ALL(:,:,9)./(PCED1(t_start:t_end)*ones(1,N_ALL)));
% Y_HSD = log(data_HSD(:,:,9)./(PCED1(t_start:t_end)*ones(1,N_HSD)));
% Y_HSG = log(data_HSG(:,:,9)./(PCED1(t_start:t_end)*ones(1,N_HSG)));
% Y_CLG = log(data_CLG(:,:,9)./(PCED1(t_start:t_end)*ones(1,N_CLG)));

Y_ALL = log(data_ALL(:,:,9)./( (PCED1(t_start:t_end)*ones(1,N_ALL)).*(data_ALL(:,:,5))) );
Y_HSD = log(data_HSD(:,:,9)./( (PCED1(t_start:t_end)*ones(1,N_HSD)).*(data_HSD(:,:,5))) );
Y_HSG = log(data_HSG(:,:,9)./( (PCED1(t_start:t_end)*ones(1,N_HSG)).*(data_HSG(:,:,5))) );
Y_CLG = log(data_CLG(:,:,9)./( (PCED1(t_start:t_end)*ones(1,N_CLG)).*(data_CLG(:,:,5))) );





K=0;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% estimate using data_ALL 
[transML, GMM_DIF1_1step, GMM_DIF1_2step, GMM_DIF1_CUE,   GMM_DIF2_1step, GMM_DIF2_2step, GMM_DIF2_CUE,   GMM_SYS1_1step, GMM_SYS1_2step, GMM_SYS1_CUE,   GMM_SYS2_1step, GMM_SYS2_2step, GMM_SYS2_CUE] = ML_GMM_estimators_ar1( Y_ALL );

resuls_transML = reshape(squeeze(transML)',(K+1)*3,1);
resuls_GMM_DIF1_1step = reshape(squeeze(GMM_DIF1_1step)',(K+1)*3,1);
resuls_GMM_DIF1_2step = reshape(squeeze(GMM_DIF1_2step)',(K+1)*3,1);
resuls_GMM_DIF1_CUE = reshape(squeeze(GMM_DIF1_CUE)',(K+1)*3,1);
resuls_GMM_DIF2_1step = reshape(squeeze(GMM_DIF2_1step)',(K+1)*3,1);
resuls_GMM_DIF2_2step = reshape(squeeze(GMM_DIF2_2step)',(K+1)*3,1);
resuls_GMM_DIF2_CUE = reshape(squeeze(GMM_DIF2_CUE)',(K+1)*3,1);
resuls_GMM_SYS1_1step = reshape(squeeze(GMM_SYS1_1step)',(K+1)*3,1);
resuls_GMM_SYS1_2step = reshape(squeeze(GMM_SYS1_2step)',(K+1)*3,1);
resuls_GMM_SYS1_CUE = reshape(squeeze(GMM_SYS1_CUE)',(K+1)*3,1);
resuls_GMM_SYS2_1step = reshape(squeeze(GMM_SYS2_1step)',(K+1)*3,1);
resuls_GMM_SYS2_2step = reshape(squeeze(GMM_SYS2_2step)',(K+1)*3,1);
resuls_GMM_SYS2_CUE = reshape(squeeze(GMM_SYS2_CUE)',(K+1)*3,1);


output_ALL = [ resuls_transML resuls_GMM_DIF1_1step resuls_GMM_DIF1_2step resuls_GMM_DIF1_CUE  resuls_GMM_DIF2_1step resuls_GMM_DIF2_2step resuls_GMM_DIF2_CUE  resuls_GMM_SYS1_1step resuls_GMM_SYS1_2step resuls_GMM_SYS1_CUE  resuls_GMM_SYS2_1step resuls_GMM_SYS2_2step resuls_GMM_SYS2_CUE  ];
format  = ' %1.4f  ';
output_ALL = num2str(output_ALL, format);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%  estimate using data_HSD 
[transML, GMM_DIF1_1step, GMM_DIF1_2step, GMM_DIF1_CUE,   GMM_DIF2_1step, GMM_DIF2_2step, GMM_DIF2_CUE,   GMM_SYS1_1step, GMM_SYS1_2step, GMM_SYS1_CUE,   GMM_SYS2_1step, GMM_SYS2_2step, GMM_SYS2_CUE] = ML_GMM_estimators_ar1( Y_HSD );

resuls_transML = reshape(squeeze(transML)',(K+1)*3,1);
resuls_GMM_DIF1_1step = reshape(squeeze(GMM_DIF1_1step)',(K+1)*3,1);
resuls_GMM_DIF1_2step = reshape(squeeze(GMM_DIF1_2step)',(K+1)*3,1);
resuls_GMM_DIF1_CUE = reshape(squeeze(GMM_DIF1_CUE)',(K+1)*3,1);
resuls_GMM_DIF2_1step = reshape(squeeze(GMM_DIF2_1step)',(K+1)*3,1);
resuls_GMM_DIF2_2step = reshape(squeeze(GMM_DIF2_2step)',(K+1)*3,1);
resuls_GMM_DIF2_CUE = reshape(squeeze(GMM_DIF2_CUE)',(K+1)*3,1);
resuls_GMM_SYS1_1step = reshape(squeeze(GMM_SYS1_1step)',(K+1)*3,1);
resuls_GMM_SYS1_2step = reshape(squeeze(GMM_SYS1_2step)',(K+1)*3,1);
resuls_GMM_SYS1_CUE = reshape(squeeze(GMM_SYS1_CUE)',(K+1)*3,1);
resuls_GMM_SYS2_1step = reshape(squeeze(GMM_SYS2_1step)',(K+1)*3,1);
resuls_GMM_SYS2_2step = reshape(squeeze(GMM_SYS2_2step)',(K+1)*3,1);
resuls_GMM_SYS2_CUE = reshape(squeeze(GMM_SYS2_CUE)',(K+1)*3,1);


output_HSD = [ resuls_transML resuls_GMM_DIF1_1step resuls_GMM_DIF1_2step resuls_GMM_DIF1_CUE  resuls_GMM_DIF2_1step resuls_GMM_DIF2_2step resuls_GMM_DIF2_CUE  resuls_GMM_SYS1_1step resuls_GMM_SYS1_2step resuls_GMM_SYS1_CUE  resuls_GMM_SYS2_1step resuls_GMM_SYS2_2step resuls_GMM_SYS2_CUE  ];
format  = ' %1.4f  ';
output_HSD = num2str(output_HSD, format);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%  estimate using data_HSG 
[transML, GMM_DIF1_1step, GMM_DIF1_2step, GMM_DIF1_CUE,   GMM_DIF2_1step, GMM_DIF2_2step, GMM_DIF2_CUE,   GMM_SYS1_1step, GMM_SYS1_2step, GMM_SYS1_CUE,   GMM_SYS2_1step, GMM_SYS2_2step, GMM_SYS2_CUE] = ML_GMM_estimators_ar1( Y_HSG );

resuls_transML = reshape(squeeze(transML)',(K+1)*3,1);
resuls_GMM_DIF1_1step = reshape(squeeze(GMM_DIF1_1step)',(K+1)*3,1);
resuls_GMM_DIF1_2step = reshape(squeeze(GMM_DIF1_2step)',(K+1)*3,1);
resuls_GMM_DIF1_CUE = reshape(squeeze(GMM_DIF1_CUE)',(K+1)*3,1);
resuls_GMM_DIF2_1step = reshape(squeeze(GMM_DIF2_1step)',(K+1)*3,1);
resuls_GMM_DIF2_2step = reshape(squeeze(GMM_DIF2_2step)',(K+1)*3,1);
resuls_GMM_DIF2_CUE = reshape(squeeze(GMM_DIF2_CUE)',(K+1)*3,1);
resuls_GMM_SYS1_1step = reshape(squeeze(GMM_SYS1_1step)',(K+1)*3,1);
resuls_GMM_SYS1_2step = reshape(squeeze(GMM_SYS1_2step)',(K+1)*3,1);
resuls_GMM_SYS1_CUE = reshape(squeeze(GMM_SYS1_CUE)',(K+1)*3,1);
resuls_GMM_SYS2_1step = reshape(squeeze(GMM_SYS2_1step)',(K+1)*3,1);
resuls_GMM_SYS2_2step = reshape(squeeze(GMM_SYS2_2step)',(K+1)*3,1);
resuls_GMM_SYS2_CUE = reshape(squeeze(GMM_SYS2_CUE)',(K+1)*3,1);


output_HSG = [ resuls_transML resuls_GMM_DIF1_1step resuls_GMM_DIF1_2step resuls_GMM_DIF1_CUE  resuls_GMM_DIF2_1step resuls_GMM_DIF2_2step resuls_GMM_DIF2_CUE  resuls_GMM_SYS1_1step resuls_GMM_SYS1_2step resuls_GMM_SYS1_CUE  resuls_GMM_SYS2_1step resuls_GMM_SYS2_2step resuls_GMM_SYS2_CUE  ];
format  = ' %1.4f  ';
output_HSG = num2str(output_HSG, format);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%  estimate using data_CLG 
[transML, GMM_DIF1_1step, GMM_DIF1_2step, GMM_DIF1_CUE,   GMM_DIF2_1step, GMM_DIF2_2step, GMM_DIF2_CUE,   GMM_SYS1_1step, GMM_SYS1_2step, GMM_SYS1_CUE,   GMM_SYS2_1step, GMM_SYS2_2step, GMM_SYS2_CUE] = ML_GMM_estimators_ar1( Y_CLG );

resuls_transML = reshape(squeeze(transML)',(K+1)*3,1);
resuls_GMM_DIF1_1step = reshape(squeeze(GMM_DIF1_1step)',(K+1)*3,1);
resuls_GMM_DIF1_2step = reshape(squeeze(GMM_DIF1_2step)',(K+1)*3,1);
resuls_GMM_DIF1_CUE = reshape(squeeze(GMM_DIF1_CUE)',(K+1)*3,1);
resuls_GMM_DIF2_1step = reshape(squeeze(GMM_DIF2_1step)',(K+1)*3,1);
resuls_GMM_DIF2_2step = reshape(squeeze(GMM_DIF2_2step)',(K+1)*3,1);
resuls_GMM_DIF2_CUE = reshape(squeeze(GMM_DIF2_CUE)',(K+1)*3,1);
resuls_GMM_SYS1_1step = reshape(squeeze(GMM_SYS1_1step)',(K+1)*3,1);
resuls_GMM_SYS1_2step = reshape(squeeze(GMM_SYS1_2step)',(K+1)*3,1);
resuls_GMM_SYS1_CUE = reshape(squeeze(GMM_SYS1_CUE)',(K+1)*3,1);
resuls_GMM_SYS2_1step = reshape(squeeze(GMM_SYS2_1step)',(K+1)*3,1);
resuls_GMM_SYS2_2step = reshape(squeeze(GMM_SYS2_2step)',(K+1)*3,1);
resuls_GMM_SYS2_CUE = reshape(squeeze(GMM_SYS2_CUE)',(K+1)*3,1);


output_CLG = [ resuls_transML resuls_GMM_DIF1_1step resuls_GMM_DIF1_2step resuls_GMM_DIF1_CUE  resuls_GMM_DIF2_1step resuls_GMM_DIF2_2step resuls_GMM_DIF2_CUE  resuls_GMM_SYS1_1step resuls_GMM_SYS1_2step resuls_GMM_SYS1_CUE  resuls_GMM_SYS2_1step resuls_GMM_SYS2_2step resuls_GMM_SYS2_CUE  ];
format  = ' %1.4f  ';
output_CLG = num2str(output_CLG, format);

%%% Summary of estimation results   %%%
name = [     ' y(-1)  coef   ';       '        se     ';    '        se_c   '; ];

T1=T-1;
m_DIF1 = T*(T-1)/2 ;
m_DIF2 = (T1*2 - 1) ;
m_SYS1 = m_DIF1 + (T-1);
m_SYS2 = m_DIF2 + (T-1);

disp(' Estimation results  ');
fprintf('  T = %d,  (t_start = %d, t_end = %d)   N_ALL = %d,  K = %d,  ', [ T1 t_start+1967 t_end+1967-1  ]);disp('  ');
fprintf('  Sample sizes of each groups:  N_ALL = %d,   N_HSD = %d,   N_HSG = %d,   N_CLG = %d,  ', [ N_ALL N_HSD N_HSG N_CLG ]);disp('  ');
fprintf('  Number of moment conditions:  DIF1  = %d,   DIF2  = %d,   SYS1  = %d,   SYS2  = %d,  ', [m_DIF1 m_DIF2 m_SYS1 m_SYS2 ]);disp('  ');
disp('  ');
disp('   ALL                  DIF1     DIF1     DIF1     DIF2     DIF2     DIF2     SYS1     SYS1     SYS1     SYS2     SYS2     SYS2   ' );
disp('               transML  1step    2step    CUE      1step    2step    CUE      1step    2step    CUE      1step    2step    CUE    ' );
disp([ name  output_ALL]);
disp('  ');
disp('   HSD                  DIF1     DIF1     DIF1     DIF2     DIF2     DIF2     SYS1     SYS1     SYS1     SYS2     SYS2     SYS2   ' );
disp('               transML  1step    2step    CUE      1step    2step    CUE      1step    2step    CUE      1step    2step    CUE    ' );
disp([ name  output_HSD]);
disp('  ');
disp('   HSG                  DIF1     DIF1     DIF1     DIF2     DIF2     DIF2     SYS1     SYS1     SYS1     SYS2     SYS2     SYS2   ' );
disp('               transML  1step    2step    CUE      1step    2step    CUE      1step    2step    CUE      1step    2step    CUE    ' );
disp([ name  output_HSG]);
disp('  ');
disp('   CLG                  DIF1     DIF1     DIF1     DIF2     DIF2     DIF2     SYS1     SYS1     SYS1     SYS2     SYS2     SYS2   ' );
disp('               transML  1step    2step    CUE      1step    2step    CUE      1step    2step    CUE      1step    2step    CUE    ' );
disp([ name  output_CLG]);
disp('  ');
disp(' Note:  "se_c" denotes corrected s.e. by Windmeijer for 2step GMM and by Newey and Windmeijer for CU-GMM ');
disp('  ');







