function [firstder]=first_derivative(n,T,dy,dx,Phi,phi,omega,sig2_u,inOmegastar)
 % vector of first derivatives of the trasformed log-likelihood in Hsiao et al 2002
% see transformed_ml.m
 
K = size(dx,3);
g = 1+T*(omega-1); 
firstder = zeros(T*K+K+4,1);
 
 for i=1:n
    DWi = [1, reshape(squeeze(dx(1:T,i,:)),K*T,1)',  zeros(1,K+1);
           zeros(T-1,1+K*T), dy(1:T-1,i), squeeze(dx(2:T,i,:))];    
    Dui =  dy(:,i) - DWi*phi;
    firstder(1:T*K+K+2,1) = firstder(1:T*K+K+2,1) + (1/sig2_u)*DWi'*inOmegastar*Dui;
    firstder(T*K+K+3,1)   = firstder(T*K+K+3,1)   + (1/(2*sig2_u*g^2))* Dui'*Phi*Dui;
    firstder(T*K+K+4,1)   = firstder(T*K+K+4,1)   + (1/(2*sig2_u^2))* Dui'*inOmegastar*Dui;
end
 
    firstder(T*K+K+3,1) = firstder(T*K+K+3,1) - (n*T)/(2*g);
    firstder(T*K+K+4,1) = firstder(T*K+K+4,1) - (n*T)/(2*sig2_u);
