function [theta,fval,exitflag,output,lambda,grad,hessian]=transformed_ml_opt(n,T,dy,dx,Phi,Omegastar,theta0,lq,uq)
 
% maximum likelihood routine. see the program transformed_ml.m
 
K = size(dx,3);
options = optimset('Display','off','GradObj','on','Hessian','user-supplied','Algorithm','trust-region-reflective'); % Turn off Display
 
[theta,fval,exitflag,output,lambda,grad,hessian]=fmincon(@likelihood,theta0,[],[],[],[],lq,uq,[],options); 
 
    function [likelihood,g,H]=likelihood(theta)
 
    phi   = theta(1:T*K+K+2,1);
    omega = theta(T*K+K+3,1);
    sigma = theta(T*K+K+4,1);

    Omegastar(1,1) = omega;
    inOmegastar = pinv(Omegastar);
 
    lik1 = (n*T/2)*log(sigma) + (n/2)*log(1+T*(omega-1));
 
    for i=1:n
    DWi = [1, reshape(squeeze(dx(1:T,i,:)),K*T,1)',  zeros(1,K+1);
           zeros(T-1,1+K*T), dy(1:T-1,i), squeeze(dx(2:T,i,:))];    
    Dui =  dy(:,i) - DWi*phi;
     lik1 = lik1 + 0.5* Dui'*inOmegastar* Dui/sigma;
    end
 
likelihood = lik1;
g = -first_derivative(n,T,dy,dx,Phi,phi,omega,sigma,inOmegastar);
H = -second_derivative(n,T,dy,dx,Phi,phi,omega,sigma,inOmegastar);
 
end
end
